From ec9b4ba0a6707be8516169f68f289caf35d80733 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Nov 28 2020 00:57:06 +0000
Subject: [PATCH 1599/2232] Avoid function name collision on __operator_eq


---

diff --git a/macro/src/expand.rs b/macro/src/expand.rs
index bd1aefa..4bd955a 100644
--- a/macro/src/expand.rs
+++ b/macro/src/expand.rs
@@ -166,10 +166,11 @@ fn expand_struct_operators(strct: &Struct) -> TokenStream {
         match derive.what {
             Trait::PartialEq => operators.extend({
                 let link_name = mangle::operator(&strct.name, "__operator_eq");
+                let local_name = format_ident!("__operator_eq_{}", strct.name.rust);
                 quote_spanned! {span=>
                     #[doc(hidden)]
                     #[export_name = #link_name]
-                    extern "C" fn __operator_eq(lhs: &#ident, rhs: &#ident) -> bool {
+                    extern "C" fn #local_name(lhs: &#ident, rhs: &#ident) -> bool {
                         *lhs == *rhs
                     }
                 }

